import { IDocValue, IKeyObjectValue } from "../../type";
import TccScriptParserVisitor from '../tccParser/tccScriptParserVisitor';
export declare class ParserUtils extends TccScriptParserVisitor<any> {
    protected _buildinVariables: Map<string, IDocValue[]>;
    protected _buildinTypes: Map<string, IDocValue[]>;
    protected _buildinConstants: Map<string, IDocValue[]>;
    protected _buildinMethods: Map<string, IDocValue[]>;
    protected _buildinFunctions: Map<string, IDocValue[]>;
    constructor(buildinObj: IKeyObjectValue);
    private _buildinHandle;
    protected _typeHandle(types?: string[], rType?: string): string;
    protected _returnTypesOtherHandle(firstArg: IKeyObjectValue, returnType: string, returnTypes: string[], name: string): string[];
    protected _checkMethodThisType(thisType: string[], type: string): boolean;
    protected _priorityComparison(currentType: string, targetType: string): boolean;
    protected _compareType(currentType: string, targetType: string, isCondition?: boolean): boolean;
    protected _compareVarType(currentType: string, targetType: string): boolean;
    protected _typeAddSeries(type: string): string;
    protected _typeAddConst(type: string): string;
    protected _getOriginMethodName(type: string, lastName: string): string;
    protected _returnedTypesParse(returnedTypes?: string[]): string[];
    protected _removePrefix(type?: string): string;
    protected _getPrefix(type: string): string;
    protected _getArrayType(name: string): string | undefined;
    protected _getMapType(name: string): string[] | undefined;
    protected _isMatrixType(type: string): boolean;
    protected _isArrayType(type: string): boolean;
    protected _isMapType(type: string): boolean;
    protected _arrayTypeConvert(type: string): string;
    protected _getMethodTypeName(type: string): string;
    protected _typeReplace(returnType: string, type: string): string;
}
